## COPY SCALE, ROTATION, BLOCK TO BOOK

## Connect to BDE
scoreboard players operation bdhelper.copy bdhelper.id = @s bdhelper.id

## Detect if attacker sneaking
execute store success score @s bdhelper.sneak_check on attacker run execute if entity @s[scores={bdhelper.sneak=1..}]
execute if score @s bdhelper.sneak_check matches 1 run tag @s add bdhelper.sneak_check

############################# IF SNEAKING
## Set BDE nbt to storage
# scale
execute if entity @s[tag=bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify storage minecraft:bdhelper_copy transformation.scale set from entity @s transformation.scale
# rotation
execute if entity @s[tag=bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify storage minecraft:bdhelper_copy Rotation set from entity @s Rotation 
# left rotation
execute if entity @s[tag=bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify storage minecraft:bdhelper_copy transformation.left_rotation set from entity @s transformation.left_rotation
# right rotation
execute if entity @s[tag=bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify storage minecraft:bdhelper_copy transformation.right_rotation set from entity @s transformation.right_rotation
# block state
execute if entity @s[tag=bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify storage minecraft:bdhelper_copy block_state.Name set from entity @s block_state.Name 
execute if entity @s[tag=bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify storage minecraft:bdhelper_copy block_state.Properties set from entity @s block_state.Properties 

## Set storage to book
execute if entity @s[tag=bdhelper.sneak_check] on attacker run item replace entity @s weapon.mainhand with written_book{display:{Name:'{"text":"Copied Data","color":"white","bold":true,"italic":false}',Lore:['{"text":"• Left click block display","color":"gray","italic":false}','{"text":" to paste the copied data.","color":"gray","italic":false}','{"text":"• Hold in offhand to place","color":"gray","italic":false}','{"text":" block display with the","color":"gray","italic":false}','{"text":" same data.","color":"gray","italic":false}','{"text":"• Sneak + Left click block","color":"gray","italic":false}','{"text":" display to copy and overide","color":"gray","italic":false}','{"text":" with new data.","color":"gray","italic":false}']},HideFlags:32,pages:['["","Scale:","\\n",{"nbt":"SelectedItem.tag.transformation.scale","entity":"@s"},"\\n","\\n","Rotation:","\\n",{"nbt":"SelectedItem.tag.Rotation","entity":"@s"},"\\n","\\n","left_rotation:","\\n",{"nbt":"SelectedItem.tag.transformation.left_rotation","entity":"@s"},"\\n","\\n","right_rotation:","\\n",{"nbt":"SelectedItem.tag.transformation.right_rotation","entity":"@s"}]','["Block State:","\\n",{"nbt":"SelectedItem.tag.block_state.Name","entity":"@s"},"\\n",{"nbt":"SelectedItem.tag.block_state.Properties","entity":"@s"}]'],title:"Copied Data",author:BDHelper,bdhelper_action:7b}
execute if entity @s[tag=bdhelper.sneak_check] on attacker run item modify entity @s weapon.mainhand bdhelper:transformation_scale
execute if entity @s[tag=bdhelper.sneak_check] on attacker run item modify entity @s weapon.mainhand bdhelper:transformation_left_rotation
execute if entity @s[tag=bdhelper.sneak_check] on attacker run item modify entity @s weapon.mainhand bdhelper:transformation_right_rotation
execute if entity @s[tag=bdhelper.sneak_check] on attacker run item modify entity @s weapon.mainhand bdhelper:rotation
execute if entity @s[tag=bdhelper.sneak_check] on attacker run item modify entity @s weapon.mainhand bdhelper:block_state_name
execute if entity @s[tag=bdhelper.sneak_check] on attacker run item modify entity @s weapon.mainhand bdhelper:block_state_properties

## Playsound
execute if entity @s[tag=bdhelper.sneak_check] run playsound entity.experience_orb.pickup master @a ~ ~ ~ 1 1

############################# IF NOT SNEAKING
## Set book to storage
execute if entity @s[tag=!bdhelper.sneak_check] on attacker run data modify storage minecraft:bdhelper_copy transformation.scale set from entity @s SelectedItem.tag.transformation.scale
execute if entity @s[tag=!bdhelper.sneak_check] on attacker run data modify storage minecraft:bdhelper_copy Rotation set from entity @s SelectedItem.tag.Rotation
execute if entity @s[tag=!bdhelper.sneak_check] on attacker run data modify storage minecraft:bdhelper_copy transformation.left_rotation set from entity @s SelectedItem.tag.transformation.left_rotation
execute if entity @s[tag=!bdhelper.sneak_check] on attacker run data modify storage minecraft:bdhelper_copy transformation.right_rotation set from entity @s SelectedItem.tag.transformation.right_rotation
execute if entity @s[tag=!bdhelper.sneak_check] on attacker run data modify storage minecraft:bdhelper_copy block_state.Name set from entity @s SelectedItem.tag.block_state.Name
execute if entity @s[tag=!bdhelper.sneak_check] on attacker run data modify storage minecraft:bdhelper_copy block_state.Properties set from entity @s SelectedItem.tag.block_state.Properties
## Set storage to BDE
execute if entity @s[tag=!bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify entity @s transformation.scale set from storage minecraft:bdhelper_copy transformation.scale
execute if entity @s[tag=!bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify entity @s Rotation set from storage minecraft:bdhelper_copy Rotation
execute if entity @s[tag=!bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify entity @s transformation.left_rotation set from storage minecraft:bdhelper_copy transformation.left_rotation
execute if entity @s[tag=!bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify entity @s transformation.right_rotation set from storage minecraft:bdhelper_copy transformation.right_rotation
execute if entity @s[tag=!bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify entity @s block_state.Name set from storage minecraft:bdhelper_copy block_state.Name
execute if entity @s[tag=!bdhelper.sneak_check] as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.copy bdhelper.id run data modify entity @s block_state.Properties set from storage minecraft:bdhelper_copy block_state.Properties

## Playsound
execute if entity @s[tag=!bdhelper.sneak_check] run playsound entity.experience_orb.pickup master @a ~ ~ ~ 1 0.8

## Remove tags + storage
tag @s remove bdhelper.sneak_check
data remove storage minecraft:bdhelper_copy transformation
data remove storage minecraft:bdhelper_copy Rotation
data remove storage minecraft:bdhelper_copy block_state
