## CHANGE BLOCK WHEN PLAYER RIGHT CLICKS

## Upload block to storage
execute as @e[type=interaction,tag=bdhelper.interaction,tag=bdhelper.unlocked] at @s unless entity @s[nbt=!{interaction:{}}] on target run data modify storage minecraft:bdhelper.block_state block_state.Name set from entity @s SelectedItem.id
## Connect to BDE
execute as @e[type=interaction,tag=bdhelper.interaction,tag=bdhelper.unlocked] at @s unless entity @s[nbt=!{interaction:{}}] run tag @s add bdhelper.rightclicked
execute as @e[type=interaction,tag=bdhelper.interaction,tag=bdhelper.rightclicked] at @s run scoreboard players operation bdhelper.change_block bdhelper.id = @s bdhelper.id
## Import block from storage to BDE
# save old block state in case
execute as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.change_block bdhelper.id run data modify storage minecraft:bdhelper.block_state old_block_state.Name set from entity @s block_state.Name
# set new block state
execute as @e[type=block_display,tag=bdhelper.block_display] at @s if score @s bdhelper.id = bdhelper.change_block bdhelper.id run data modify entity @s block_state.Name set from storage minecraft:bdhelper.block_state block_state.Name
# if air or barrier, set white concrete
execute as @e[type=block_display,tag=bdhelper.block_display,nbt={block_state:{Name:"minecraft:air"}}] at @s if score @s bdhelper.id = bdhelper.change_block bdhelper.id run data modify entity @s block_state.Name set from storage minecraft:bdhelper.block_state old_block_state.Name
execute as @e[type=block_display,tag=bdhelper.block_display,nbt={block_state:{Name:"minecraft:barrier"}}] at @s if score @s bdhelper.id = bdhelper.change_block bdhelper.id run data modify entity @s block_state.Name set from storage minecraft:bdhelper.block_state old_block_state.Name


## Clear everything
execute as @e[type=interaction,tag=bdhelper.interaction] at @s unless entity @s[nbt=!{interaction:{}}] run data remove entity @s interaction
execute as @e[type=interaction,tag=bdhelper.interaction,tag=bdhelper.rightclicked] at @s run data remove storage minecraft:bdhelper.block_state old_block_state.Name
execute as @e[type=interaction,tag=bdhelper.interaction,tag=bdhelper.rightclicked] at @s run data remove storage minecraft:bdhelper.block_state block_state.Name
execute as @e[type=interaction,tag=bdhelper.interaction,tag=bdhelper.rightclicked] at @s run scoreboard players reset bdhelper.change_block bdhelper.id
execute as @e[type=interaction,tag=bdhelper.interaction,tag=bdhelper.rightclicked] at @s run tag @s remove bdhelper.rightclicked